-----------------------------
-- BGET.E             v1.0 --
-- (c) 1999 Gabriel Boehme --
-- requires  Euphoria 2.1+ --
-----------------------------

without trace

include get.e
include machine.e

type string(sequence s) -- string8
object x
   for i = 1 to length(s) do
      x = s[i]
      if integer(x) then
	 if x < 0 then
	    return 0
	 elsif x > #FF then
	    return 0
	 end if
      else
	 return 0
      end if
   end for
   return 1
end type

integer fn, stype, atype, byte
atom sign, a

constant ZERO = 0, BYTE = 1, INT16 = 2, INT32 = 4, FLOAT64 = 8
		-- -BYTE #F, -INT16 #E, -INT32 #C
constant NONE = 0, SEQUENCE = 1, STRING = 2

procedure Print(object x)
integer len
sequence s
   if atom(x) then
      sign = compare(x, 0) --sign
      a = x * sign --absolute value
      if integer(a) then
	 if a = 0 then
	    atype = ZERO
	    s = {}
	 elsif a <= #FF then
	    atype = BYTE * sign
	    s = {a}
	 elsif a <= #FFFF then
	    atype = INT16 * sign
	    s = {remainder(a,#100), floor(a/#100)}
	 else
	    atype = INT32 * sign
	    s = int_to_bytes(a)
	 end if
      elsif a = floor(a) and a <= #FFFFFFFF then
	 atype = INT32 * sign
	 s = int_to_bytes(a)
      else
	 atype = FLOAT64
	 s = atom_to_float64(x)
      end if
      if atype < 0 then
	 atype += #10
      end if
      if stype then
	 atype += stype * #10
	 stype = NONE
      end if
      puts(fn, prepend(s, atype))
   else
      s = x
      len = length(s)
      if string(s) then
	 stype = STRING
	 Print(len)
	 puts(fn, s)
      else
	 stype = SEQUENCE
	 Print(len)
	 for i = 1 to len do
	    Print(s[i])
	 end for
      end if
   end if
end procedure

global procedure bprint(integer file, object x)
   fn = file
   stype = NONE
   Print(x)
end procedure


function Get()
integer len
sequence s, g
   byte = getc(fn)
   if byte = -1 then
      return {GET_EOF}
   end if

   atype = remainder(byte, #10)
   stype = floor(byte/#10)

   if atype > FLOAT64 then
      atype = #10 - atype
      sign = -1
   else
      sign = 1
   end if

   if atype = ZERO then
      a = 0
   elsif atype = BYTE then
      a = getc(fn)
      if a = -1 then
	 return {GET_EOF, 0}
      end if
      a *= sign
   elsif atype = INT16 then
      s = get_bytes(fn, 2)
      if length(s) != 2 then
	 return {GET_EOF, s}
      end if
      a = (s[1] + s[2] * #100) * sign
   elsif atype = INT32 then
      s = get_bytes(fn, 4)
      if length(s) != 4 then
	 return {GET_EOF, s}
      end if
      a = bytes_to_int(s) * sign
   elsif atype = FLOAT64 then
      s = get_bytes(fn, 8)
      if length(s) != 8 then
	 return {GET_EOF, s}
      end if
      a = float64_to_atom(s)
   else
      return {GET_FAIL, byte}
   end if

   if stype then
      len = a
      if stype = STRING then
	 s = get_bytes(fn, len)
	 if length(s) != len then
	    return {GET_EOF, s}
	 end if
      elsif stype = SEQUENCE then
	 s = repeat(0, len)
	 for i = 1 to len do
	    g = Get()
	    if g[1] != GET_SUCCESS then
	       return g
	    end if
	    s[i] = g[2]
	 end for
      else
	 return {GET_FAIL, byte}
      end if

      return {GET_SUCCESS, s}
   else
      return {GET_SUCCESS, a}
   end if
end function

global function bget(integer file)
   fn = file
   return Get()
end function


-- In Euphoria 2.1 this file (unless modified) is FREE - 0 statements.
with 18165077 -- delete this statement if it causes an error

